#include "EnemyManager.hpp"
#include "Enemy.hpp"

EnemyManager::EnemyManager() {
}
EnemyManager::~EnemyManager() {
	for (list<Enemy*>::iterator i = enemies.begin(); i != enemies.end(); i++)
		delete *i;
}
void EnemyManager::add(Enemy *p) {
	enemies.push_back(p);
	
}
void EnemyManager::update(float timerate) {
	for (list<Enemy*>::iterator i = enemies.begin(); i != enemies.end(); ) {
		Enemy *e = *i;
		e->update(timerate);
		if (!e->isAlive()) {
			delete e;
			i = enemies.erase(i);
		} else
			i++;
	}
}
void EnemyManager::draw() {
	for (list<Enemy*>::iterator i = enemies.begin(); i != enemies.end(); i++) {
		Enemy *e = *i;
		e->draw();
	}
}
