#include "InputManager.hpp"

#include "InputHandler.hpp"
#include "Input.hpp"

InputManager::InputManager() {
}
InputManager::~InputManager() {
	for (vector<InputHandler*>::iterator i = handlers.begin(); i != handlers.end(); ++i) {
		delete *i;
	}
}

void InputManager::add(InputHandler *handler) {
	handlers.push_back(handler);
}
Input *InputManager::newInput() {
	for (vector<InputHandler*>::iterator i = handlers.begin(); i != handlers.end(); ++i) {
		Input *input = (*i)->newInput();
		if (input)
			return input;
	}
	return 0;
}
Input *InputManager::newInput(const char *deviceName, const char *buttonName) {
	for (vector<InputHandler*>::iterator i = handlers.begin(); i != handlers.end(); ++i) {
		InputHandler *ih = *i;
		if (strcmpi(ih->getName(), deviceName) == 0) {
			Input *input = ih->newInput(buttonName);
			if (input)
				return input;
		}
	}
	return 0;
}

void InputManager::poll() {
	for (vector<InputHandler*>::iterator i = handlers.begin(); i != handlers.end(); ++i)
		(*i)->poll();
}

