#include "MouseInput.hpp"

#include <allegro.h>

MouseInput::MouseInput(MouseHandler *handler, int _type) : Input((InputHandler*)handler) {
	type = _type;
}

MouseInput::~MouseInput() {
}

const char *MouseInput::getName() {
	return MOUSE_NAMES[type];
}
const int MouseInput::NONE		= 0;
const int MouseInput::LEFT		= 1;
const int MouseInput::RIGHT		= 2;
const int MouseInput::MIDDLE	= 3;
const int MouseInput::X			= 4;
const int MouseInput::Y			= 5;
const int MouseInput::MOUSE_MAX	= 6;


bool MouseInput::isAnalog() { 
	switch (type) {
		case X:
		case Y:
			return true;
	}
	return false;
	
}
int MouseInput::getValue() {
	switch (type) {
		case LEFT:
			return ::mouse_b&1;
		case RIGHT:
			return ::mouse_b&2;
		case MIDDLE:
			return ::mouse_b&4;
		case X:
		case Y:
			int mickeyx,mickeyy;
			::get_mouse_mickeys(&mickeyx, &mickeyy);
			
			return type==X ? mickeyx : mickeyy;
	}
	return 0;
}
const char *MouseInput::MOUSE_NAMES[] = {
   "None",     "Left Click",          "Right Click",          "Middle Click",
   "Mouse X", "Mouse Y", };
