#include "MusicPlayer.h"

#include "Music.h"
#include "Random.h"

MusicPlayer::MusicPlayer() {
	dumb_register_stdfiles();
	install_sound(DIGI_AUTODETECT, MIDI_NONE, NULL);
	dp = 0;
	currentTrack = 0;
}

MusicPlayer::~MusicPlayer() {
	stop();
	dumb_exit();
}

void MusicPlayer::update() {
	if (dp!=0) {
		if (al_poll_duh(dp) != 0)
			play();
	}
}

void MusicPlayer::add(Music *music) {
	tracks.push_back(music);
}

void MusicPlayer::play(Music *music, bool loop) {
	stop();

	if (music == 0) {
		if (tracks.size()==1)
			music = tracks[0];
		else do {
			music = tracks[Random::intIn(tracks.size())];
		} while (currentTrack == music);
	}

	currentTrack = music;

	dp = al_start_duh(music->getDUH(), 2, 0, 1.0f, 4096, 48000);

	if (!loop) {
		// Stop music from looping
		DUH_SIGRENDERER *sr = al_duh_get_sigrenderer(dp);
		DUMB_IT_SIGRENDERER *itsr = duh_get_it_sigrenderer(sr);
		dumb_it_set_loop_callback(itsr, &dumb_it_callback_terminate, NULL);
		dumb_it_set_xm_speed_zero_callback(itsr, &dumb_it_callback_terminate, NULL);
	}
}
void MusicPlayer::stop() {
	if (dp==0) return;
	al_stop_duh(dp);
	dp = 0;
}

