#ifndef _PLAYER_H
#define _PLAYER_H

#include "global.h"

#include "Sprite.hpp"
#include "Animation.hpp"

class GameFrame;

class Player : public Sprite {
	public:
		Player(GameFrame *frame);
		~Player();
		void update(float timerate);
		void draw();
		void damage(float amount);
	public:
		Poly xshape,yshape;
		Placement placement;
		Vec2D offset,armpos;
		Vec2D delta;
		Bitmap *arm;
		Anim ascii;
		Anim run,jump,stand,hurting;
		float hurt;
		Anim *anim;
		float angle;
		bool flip;
		bool onground;
		int groundtype;
		int onside;
		float charge;
		int jumpcount;
		float rate;
		float health;
		float power;
	public:
		GameFrame *frame;
};

#endif
