#ifndef _VIRTUAL_JOYSTICK_H
#define _VIRTUAL_JOYSTICK_H

#include <map>


class InputManager;
class Input;

using namespace std;

class VirtualJoystick {
	public: 
		VirtualJoystick(InputManager &inputManager);
		virtual ~VirtualJoystick();
		
		virtual Input *getInput(int id);
		
		virtual void addInput(int id, Input *input);

		virtual bool queryInput(int id);
		virtual void setInput(int id, const char *deviceName, const char *buttonName);
		
		virtual void poll();
		
		enum Buttons {
			BUTTON_NULL = 0,
			
			UP,
			DOWN,
			LEFT,
			RIGHT,
			
			BUTTON_START,
			
			A, B, C,
			X, Y, Z,
			
			B1,  B2,  B3,  B4, 
			B5,  B6,  B7,  B8,
			B9,  B10, B11, B12,
			B13, B14, B15, B16
		};
		


	private:
	
		map<int, Input*> buttons;
	
		InputManager &inputManager;
		
};

#endif

