////////////////////////////////////////////////////////////////////////////////
#ifndef __gamepad_h__
#define __gamepad_h__

////////////////////////////////////////////////////////////////////////////////
#include <string>
#include <map>
#include <vector>

#include <allegro.h>

////////////////////////////////////////////////////////////////////////////////
class Button
{
public:
	virtual ~Button() { }
	
	virtual bool isDown() = 0;
};

////////////////////////////////////////////////////////////////////////////////
class Gamepad
{
private:
	std::vector<Button *> bindings;
public:
	Gamepad();
	Gamepad(int numkeys);
	~Gamepad();

	
	bool isDown(int id);

	void bind(int id, Button *btn);
};
////////////////////////////////////////////////////////////////////////////////

#endif
